  '
  ' PLAYFLI.BAS 1.0 for PDS 7.1
  '
  DEFINT A-Z
  '
  CONST TRUE = -1, FALSE = 0
  '
  '$INCLUDE: 'PLAYFLI.BI'
  '$INCLUDE: 'FLIASM.BI'
  '

FUNCTION PlayFLI% (FiName$, BYVAL NumLoops%, BYVAL Speed%, BYVAL ShowDelay%, BYVAL ShownDelay%, BYVAL FadeInSpeed%, BYVAL FadeOutSpeed%, BYVAL AbortCheck%, BYVAL UseXMS%)

  '
  GRAB24
  '
  IF FRE(-1) < (65520 + 8192) THEN status% = 108: GOTO PFExit
  REDIM FLIBuf(0 TO 65520 \ 4) AS LONG
  '
  REDIM Pal(0 TO 1536 \ 4) AS LONG
  DefaultPal VARSEG(Pal(0)), 0
  '
  MouseFlag% = MouseDetect%
  '
  DIM filename AS STRING * 150
  '
  filename = FiName$ + CHR$(0)
  status% = FILEOPEN%(VARPTR(filename), 0, Handle%)
  IF status% GOTO PFExit
  '
  status% = FILEREAD%(Handle%, VARPTR(filename), VARSEG(filename), 128)
  IF status% GOTO PFExit
  '
  FLIMagic% = CVI(MID$(filename, 5, 2))
  FLIFrames% = CVI(MID$(filename, 7, 2))
  FLIX% = CVI(MID$(filename, 9, 2))
  FLIY% = CVI(MID$(filename, 11, 2))
  FLIDepth% = ASC(MID$(filename, 13, 1))
  FLITicks% = ASC(MID$(filename, 17, 2))
  IF Speed% <> 0 THEN FLITicks% = Speed% - 1
  '
  'Don't check if FLIDepth% = 8 that's an unreliable indicator!
  IF FLIMagic% <> &HAF11 THEN
    status = NOTFLI
    GOTO PFExit
  END IF
  '
  IF FLIFrames% > 4000 OR FLIX% <> 320 OR FLIY% <> 200 THEN
    status% = UNSUPPORTED
    GOTO PFExit
  END IF
  '
  IF UseXMS% THEN
    IF XMSInit% = 0 THEN
      IF XMSMaxFree(i%) = 0 THEN
        IF i% > 0 THEN

          status% = FILESEEK%(Handle%, 0, 0)

          status% = FILESIZE%(Handle%, BytesToRead&)
          IF status% GOTO PFExit
          j% = (BytesToRead& + 16 + 1023) \ 1024

          IF i% > j% THEN i% = j%

          IF XMSAllocate%(i%, XMSHandle%) = 0 THEN

            AmountInXMS& = i% * 1024&

            BytesLeft& = BytesToRead&

            IF BytesLeft& > AmountInXMS& THEN
              BytesLeft& = AmountInXMS&
            END IF

            DO WHILE BytesLeft&
              BytesToRead& = 64512
              IF BytesToRead& > BytesLeft& THEN BytesToRead& = BytesLeft&

              status% = FILEREAD%(Handle%, 0, VARSEG(FLIBuf(0)), LONG2INT%(BytesToRead&))
              IF status% THEN GOTO PFExit

              IF CopyToXMS%(XMSHandle%, XMSOffset&, VARSEG(FLIBuf(0)), 0, (BytesToRead& + 1) AND &HFFFFFFFE) THEN
                GOTO XMSERROR
              END IF

              XMSOffset& = XMSOffset& + BytesToRead&

              BytesLeft& = BytesLeft& - BytesToRead&
            LOOP

          END IF
        END IF
      END IF
    END IF
  END IF
  '
  FirstFrame% = 1
  LastFrame% = FLIFrames%
  IF NumLoops% THEN
    LastFrame% = LastFrame% + 1
  END IF
  '
  XMSEnd& = AmountInXMS& - 1
  '
  FileOffset& = 128
  DiskOffset& = 128
  '
  GOCLOCK
  IF FLITicks% < 400 THEN
    FLITicks% = FLITicks% * 66
  ELSE
    FLITicks% = 400 * 66
  END IF
  '
  IF AbortCheck% THEN
    DO: LOOP WHILE LEN(INKEY$)
    IF MouseFlag% THEN
      DO: LOOP WHILE MouseEnter%
      DO: LOOP WHILE MouseEscape%
    END IF
  END IF
  '
  ShowStartTime& = INT2LONG&(GETINT%(0, &H46C))
  '
  DO
    '
    FOR FrameNum% = FirstFrame% TO LastFrame%
      '
      DestTime& = (GETCLOCK& + FLITicks%) MOD &H1800B000
      '402698240 total clock ticks per day
      'make sure clock doesn't roll over and fool our timer in the IDE
      IF DestTime& > 402697984 THEN DestTime& = 0
      '
      IF DisplayTime% THEN
        IF ((INT2LONG&(GETINT%(0, &H46C)) - ShowStartTime&) AND &HFFFF) >= DisplayTime% THEN
          GOTO FLINormalEnd
        END IF
      END IF
      '
      IF FrameNum% = 2 THEN
        FrameTwo& = FileOffset&
      END IF
      '
      ReadSeg% = VARSEG(filename)
      ReadOfs& = VARPTR(filename)
      ReadLen& = 16
      GOSUB FILEREAD
      '
      FrameSize& = CVL(MID$(filename, 1, 4)) - 16
      FrameMagic% = CVI(MID$(filename, 5, 2))
      FrameChunks% = CVI(MID$(filename, 7, 2))
      IF FrameMagic% <> &HF1FA THEN GOTO PFCorrupted
      '
      IF FrameSize& <> 0 THEN

        IF FrameSize& > 65500 THEN GOTO PFCorrupted
        '
        ReadSeg% = VARSEG(FLIBuf(0))
        ReadOfs& = 0
        ReadLen& = FrameSize&
        GOSUB FILEREAD
        '
        o& = 0

        BytesLeft& = FrameSize&

        IF FrameNum% = 1 THEN
          SCREENOFF
          SOff% = TRUE
        ELSE
          WAITWHILEIN
          WAITWHILEOUT
        END IF

        FOR i% = 1 TO FrameChunks%

          ChunkSize& = GETLONG&(VARSEG(FLIBuf(0)), LONG2INT%(o&))
          ChunkType% = GETINT%(VARSEG(FLIBuf(0)), LONG2INT%(o& + 4))
          IF ChunkSize& > BytesLeft& GOTO PFCorrupted

          SELECT CASE ChunkType%
          CASE 11
            PalUnComp VARSEG(FLIBuf(0)), LONG2INT%(o& + 6)
          CASE 12
            LCUnComp VARSEG(FLIBuf(0)), LONG2INT%(o& + 6), &HA000, 0
          CASE 13
            MemClear &HA000, 0, &HFA00, 0
          CASE 15
            UnComp 200, VARSEG(FLIBuf(0)), LONG2INT%(o& + 6), &HA000, 0
            IF FrameNum% = 1 THEN GOSUB FLIStart
          CASE 16
            IF BytesLeft& < 64000 GOTO PFCorrupted
            MemMove VARSEG(FLIBuf(0)), LONG2INT%(o& + 6), &HA000, 0, &HFA00
            IF FrameNum% = 1 THEN GOSUB FLIStart
          CASE ELSE
            GOTO PFCorrupted
          END SELECT

          o& = o& + ChunkSize&
          BytesLeft& = BytesLeft& - ChunkSize&
        NEXT

      END IF
      '
      IF SOff% THEN SCREENON: SOff% = FALSE
      '
      GOSUB CheckAbort: IF abortflag% THEN GOTO FLIEnd
      '
      DO
        CurrentTime& = GETCLOCK&
      LOOP WHILE (CurrentTime& < DestTime&)
      '
    NEXT
    '
    IF NumLoops% = 0 THEN
      GOTO FLINormalEnd
    ELSE
      FirstFrame% = 2
      LastFrame% = FLIFrames% + 1
      FileOffset& = FrameTwo&

      NumLoops% = NumLoops% - 1
      'IF NumLoops% = 0 THEN LastFrame% = FLIFrames%
    END IF
    '
  LOOP
  '
PFExit:
  '
  IF status% = READPASTEOF THEN status% = CORRUPTED
  '
  IF Handle% THEN FILECLOSE Handle%
  IF XMSHandle% THEN i% = XMSFree(XMSHandle%)
  '
  RELEASE24
  '
  PlayFLI% = status%
  '
  IF SOff% THEN SCREENON
  '
EXIT FUNCTION
  '
PFCorrupted:
  status% = CORRUPTED
GOTO PFExit
  '
XMSERROR:
  status = XMSERROR
GOTO PFExit
  ' virtual data read from disk and/or XMS
FILEREAD:

  IF ReadLen& = 0 THEN RETURN

  ReadStart& = FileOffset&
  ReadEnd& = FileOffset& + ReadLen& - 1

  IF ReadEnd& <= XMSEnd& THEN

    status% = CopyFromXMS%(XMSHandle%, FileOffset&, ReadSeg%, LONG2INT%(ReadOfs&), (ReadLen& + 1) AND &HFFFFFFFE)
    IF status% THEN GOTO XMSERROR
    FileOffset& = FileOffset& + ReadLen&

    RETURN

  ELSEIF ReadStart& <= XMSEnd& AND ReadEnd& > XMSEnd& THEN

    BytesToCopy& = (XMSEnd& - ReadStart&) + 1

    status% = CopyFromXMS%(XMSHandle%, FileOffset&, ReadSeg%, LONG2INT%(ReadOfs&), (BytesToCopy& + 1) AND &HFFFFFFFE)
    IF status% THEN GOTO XMSERROR

    FileOffset& = FileOffset& + BytesToCopy&

    ReadOfs& = ReadOfs& + BytesToCopy&
    ReadLen& = ReadLen& - BytesToCopy&

  END IF

  IF DiskOffset& <> FileOffset& THEN
    status% = FILESEEK%(Handle%, 0, FileOffset&)
    IF status% GOTO PFExit
    DiskOffset& = FileOffset&
  END IF

  status% = FILEREAD%(Handle%, LONG2INT%(ReadOfs&), ReadSeg%, LONG2INT%(ReadLen&))
  IF status% GOTO PFExit

  DiskOffset& = DiskOffset& + ReadLen&
  FileOffset& = FileOffset& + ReadLen&

RETURN
'
GetPal:
  OUT &H3C7, 0
  DEF SEG = VARSEG(Pal(0))
  FOR i% = 0 TO 767
    POKE i%, INP(&H3C9)
  NEXT
RETURN
'
FLIStart:
  IF AlreadyDelayed% THEN RETURN

  AlreadyDelayed% = TRUE

  IF FadeInSpeed% THEN
    GOSUB GetPal
    FOR q% = 0 TO 256 STEP FadeInSpeed%
      FADEPAL 256, q%, VARSEG(Pal(0)), 0, 768
      SETPAL 256, VARSEG(Pal(0)), 768
      IF q% = 0 THEN SCREENON: SOff% = FALSE
    NEXT
    IF (q% - FadeInSpeed%) <> 256 THEN
      FADEPAL 256, 256, VARSEG(Pal(0)), 0, 768
      SETPAL 256, VARSEG(Pal(0)), 768
    END IF
  ELSE
    SCREENON
    SOff% = FALSE
  END IF

  FOR q% = 1 TO ShowDelay%
    z% = GETINT%(&H0, &H46C)
    DO: LOOP WHILE GETINT%(&H0, &H46C) = z%
    GOSUB CheckAbort: IF abortflag% THEN GOTO FLIEnd
  NEXT

RETURN
'
FLINormalEnd:
  FOR q% = 1 TO ShownDelay%
    z% = GETINT%(&H0, &H46C)
    DO: LOOP WHILE GETINT%(&H0, &H46C) = z%
    GOSUB CheckAbort: IF abortflag% THEN EXIT FOR
  NEXT
'
FLIEnd:

  IF FadeOutSpeed% THEN
    GOSUB GetPal
    FOR q% = 256 TO 0 STEP -FadeOutSpeed%
      FADEPAL 256, q%, VARSEG(Pal(0)), 0, 768
      SETPAL 256, VARSEG(Pal(0)), 768
    NEXT
    IF (q% + FadeOutSpeed%) <> 0 THEN
      FADEPAL 256, 0, VARSEG(Pal(0)), 0, 768
      SETPAL 256, VARSEG(Pal(0)), 768
    END IF
  END IF

FLIClear:
  SCREENOFF
  SOff% = TRUE
  MemClear &HA000, 0, &HFA00, 0
  DefaultPal VARSEG(Pal(0)), 0
  SETPAL 256, VARSEG(Pal(0)), 0
  SCREENON
  SOff% = FALSE
GOTO PFExit
'
CheckAbort:
  status% = 0: abortflag% = FALSE

  IF AbortCheck% THEN
    A$ = INKEY$

    IF LEN(A$) THEN
      abortflag% = TRUE
      IF A$ = CHR$(27) THEN
        status% = ABORTED
      END IF
    END IF

    IF MouseFlag% THEN
      IF MouseEnter% THEN
        abortflag% = TRUE
      END IF
      IF MouseEscape% THEN
        abortflag% = TRUE
        status% = ABORTED
      END IF
    END IF
  END IF
RETURN

END FUNCTION

